<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Predictores de saltos, IE-0521: Referencia de la Clase predictor</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Predictores de saltos, IE-0521
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generado por Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Buscar');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Buscar');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Métodos públicos</a> &#124;
<a href="#pub-attribs">Atributos públicos</a> &#124;
<a href="classpredictor-members.html">Lista de todos los miembros</a>  </div>
  <div class="headertitle">
<div class="title">Referencia de la Clase predictor</div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="predictor_8hpp_source.html">predictor.hpp</a>&gt;</code></p>
<div class="dynheader">
Diagrama de herencias de predictor</div>
<div class="dyncontent">
<div class="center"><img src="classpredictor__inherit__graph.png" border="0" usemap="#predictor_inherit__map" alt="Inheritance graph"/></div>
<map name="predictor_inherit__map" id="predictor_inherit__map">
<area shape="rect" id="node2" href="classbimodal.html" title="bimodal" alt="" coords="5,80,72,107"/>
<area shape="rect" id="node3" href="classhglobal.html" title="hglobal" alt="" coords="97,80,159,107"/>
<area shape="rect" id="node4" href="classprivado.html" title="privado" alt="" coords="184,80,248,107"/>
<area shape="rect" id="node5" href="classtorneo.html" title="torneo" alt="" coords="272,80,331,107"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">significado de colores y flechas</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Métodos públicos</h2></td></tr>
<tr class="memitem:a941df172254db3b9e8a2d35e4a96ad29"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classpredictor.html#a941df172254db3b9e8a2d35e4a96ad29">predictor</a> ()</td></tr>
<tr class="separator:a941df172254db3b9e8a2d35e4a96ad29"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a77e91f8c0568eef9e714804644bb72ef"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classpredictor.html#a77e91f8c0568eef9e714804644bb72ef">~predictor</a> ()</td></tr>
<tr class="separator:a77e91f8c0568eef9e714804644bb72ef"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7e7c6a5236780206a9c012350cc48933"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classpredictor.html#a7e7c6a5236780206a9c012350cc48933">resumen</a> (int s, int tp, int gh, int ph)</td></tr>
<tr class="separator:a7e7c6a5236780206a9c012350cc48933"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a693b1b900ef423fe30830ed76973a41c"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classpredictor.html#a693b1b900ef423fe30830ed76973a41c">salida</a> (long progctr, char result, char pred, string dir)</td></tr>
<tr class="separator:a693b1b900ef423fe30830ed76973a41c"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-attribs"></a>
Atributos públicos</h2></td></tr>
<tr class="memitem:a8e2d672fbbe6f7e16d12592f8801f39f"><td class="memItemLeft" align="right" valign="top">int *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classpredictor.html#a8e2d672fbbe6f7e16d12592f8801f39f">t_predictores</a></td></tr>
<tr class="separator:a8e2d672fbbe6f7e16d12592f8801f39f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3c1e9e7e0f463ab18af8229755d52b7e"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classpredictor.html#a3c1e9e7e0f463ab18af8229755d52b7e">numbits</a></td></tr>
<tr class="separator:a3c1e9e7e0f463ab18af8229755d52b7e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a40ea9fec251f1ff52548581f67f6dc9c"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classpredictor.html#a40ea9fec251f1ff52548581f67f6dc9c">t_tamano</a></td></tr>
<tr class="separator:a40ea9fec251f1ff52548581f67f6dc9c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab384ccca87d54dbcf85ddae02fc6267a"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classpredictor.html#ab384ccca87d54dbcf85ddae02fc6267a">pc_mask</a></td></tr>
<tr class="separator:ab384ccca87d54dbcf85ddae02fc6267a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a08e296402b83daab316fa4f5f02686b2"><td class="memItemLeft" align="right" valign="top">long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classpredictor.html#a08e296402b83daab316fa4f5f02686b2">numbranches</a></td></tr>
<tr class="separator:a08e296402b83daab316fa4f5f02686b2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abc7378342ef4e20ac7881dbc8bff1e72"><td class="memItemLeft" align="right" valign="top">long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classpredictor.html#abc7378342ef4e20ac7881dbc8bff1e72">tt</a></td></tr>
<tr class="separator:abc7378342ef4e20ac7881dbc8bff1e72"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a96e452119dc7e1c11e6045d2ec11ce8a"><td class="memItemLeft" align="right" valign="top">long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classpredictor.html#a96e452119dc7e1c11e6045d2ec11ce8a">ft</a></td></tr>
<tr class="separator:a96e452119dc7e1c11e6045d2ec11ce8a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6cb6a35b879350a019dd2e23260d8983"><td class="memItemLeft" align="right" valign="top">long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classpredictor.html#a6cb6a35b879350a019dd2e23260d8983">tn</a></td></tr>
<tr class="separator:a6cb6a35b879350a019dd2e23260d8983"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a65bfa951fc76a4f5de411d82b3a3b73c"><td class="memItemLeft" align="right" valign="top">long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classpredictor.html#a65bfa951fc76a4f5de411d82b3a3b73c">fn</a></td></tr>
<tr class="separator:a65bfa951fc76a4f5de411d82b3a3b73c"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Descripción detallada</h2>
<div class="textblock"><p>La clase predictor es una superclase para hacer uso de la herencia y aprovechar así los elementos en común para los distintos predictores, tanto a nivel de atributos como a nivel de métodos. </p>
</div><h2 class="groupheader">Documentación del constructor y destructor</h2>
<a id="a941df172254db3b9e8a2d35e4a96ad29"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a941df172254db3b9e8a2d35e4a96ad29">&#9670;&nbsp;</a></span>predictor()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">predictor::predictor </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Constructor por defecto </p>

</div>
</div>
<a id="a77e91f8c0568eef9e714804644bb72ef"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a77e91f8c0568eef9e714804644bb72ef">&#9670;&nbsp;</a></span>~predictor()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">predictor::~predictor </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Destructor por defecto </p>

</div>
</div>
<h2 class="groupheader">Documentación de las funciones miembro</h2>
<a id="a7e7c6a5236780206a9c012350cc48933"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7e7c6a5236780206a9c012350cc48933">&#9670;&nbsp;</a></span>resumen()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void predictor::resumen </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>s</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>tp</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>gh</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>ph</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Método de impresión genérico de atributos de los predictores </p><dl class="params"><dt>Parámetros</dt><dd>
  <table class="params">
    <tr><td class="paramname">s</td><td>Parámetro s que indica la cantidad de bits para el tamaño de la tabla 2^s </td></tr>
    <tr><td class="paramname">tp</td><td>Valor para identificar el tipo de predictor. </td></tr>
    <tr><td class="paramname">gh</td><td>Cantidad de bits usados para almacenar historia global. </td></tr>
    <tr><td class="paramname">ph</td><td>Cantidad de bits usados para almacenar historia privada. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a693b1b900ef423fe30830ed76973a41c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a693b1b900ef423fe30830ed76973a41c">&#9670;&nbsp;</a></span>salida()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void predictor::salida </td>
          <td>(</td>
          <td class="paramtype">long&#160;</td>
          <td class="paramname"><em>progctr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">char&#160;</td>
          <td class="paramname"><em>result</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">char&#160;</td>
          <td class="paramname"><em>pred</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>dir</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Método de escritura de los resultados a un archivo de texto </p><dl class="params"><dt>Parámetros</dt><dd>
  <table class="params">
    <tr><td class="paramname">progctr</td><td>Contador de programa </td></tr>
    <tr><td class="paramname">result</td><td>Output del salto </td></tr>
    <tr><td class="paramname">pred</td><td>Predicción realizada </td></tr>
    <tr><td class="paramname">dir</td><td>Directorio y nombre de archivo para escritura. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Documentación de los datos miembro</h2>
<a id="a65bfa951fc76a4f5de411d82b3a3b73c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a65bfa951fc76a4f5de411d82b3a3b73c">&#9670;&nbsp;</a></span>fn</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">long predictor::fn</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Cantidad de saltos tomados pronosticados como no tomados </p>

</div>
</div>
<a id="a96e452119dc7e1c11e6045d2ec11ce8a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a96e452119dc7e1c11e6045d2ec11ce8a">&#9670;&nbsp;</a></span>ft</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">long predictor::ft</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Cantidad de saltos no tomados pronosticados como tomados </p>

</div>
</div>
<a id="a3c1e9e7e0f463ab18af8229755d52b7e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3c1e9e7e0f463ab18af8229755d52b7e">&#9670;&nbsp;</a></span>numbits</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int predictor::numbits</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Cantidad de bits para bht </p>

</div>
</div>
<a id="a08e296402b83daab316fa4f5f02686b2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a08e296402b83daab316fa4f5f02686b2">&#9670;&nbsp;</a></span>numbranches</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">long predictor::numbranches</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Cantidad de branches analizados </p>

</div>
</div>
<a id="ab384ccca87d54dbcf85ddae02fc6267a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab384ccca87d54dbcf85ddae02fc6267a">&#9670;&nbsp;</a></span>pc_mask</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int predictor::pc_mask</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Máscara para aislar la cantidad de bits del pc deseada </p>

</div>
</div>
<a id="a8e2d672fbbe6f7e16d12592f8801f39f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8e2d672fbbe6f7e16d12592f8801f39f">&#9670;&nbsp;</a></span>t_predictores</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int* predictor::t_predictores</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Puntero para almacenar tabla bht, representados en ints 0: SN, 1: WN, 2: WT y 3: ST </p>

</div>
</div>
<a id="a40ea9fec251f1ff52548581f67f6dc9c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a40ea9fec251f1ff52548581f67f6dc9c">&#9670;&nbsp;</a></span>t_tamano</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int predictor::t_tamano</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Tamaño de la bht </p>

</div>
</div>
<a id="a6cb6a35b879350a019dd2e23260d8983"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6cb6a35b879350a019dd2e23260d8983">&#9670;&nbsp;</a></span>tn</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">long predictor::tn</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Cantidad de saltos no tomados pronosticados como no tomados </p>

</div>
</div>
<a id="abc7378342ef4e20ac7881dbc8bff1e72"></a>
<h2 class="memtitle"><span class="permalink"><a href="#abc7378342ef4e20ac7881dbc8bff1e72">&#9670;&nbsp;</a></span>tt</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">long predictor::tt</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Cantidad de saltos tomados pronosticados como tomados </p>

</div>
</div>
<hr/>La documentación para esta clase fue generada a partir del siguiente fichero:<ul>
<li>include/<a class="el" href="predictor_8hpp_source.html">predictor.hpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generado por &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
